#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...
# task: use the perl find module to check all files in a
# directory tree for some property, and return a list...

use File::Find;
my %filelist; # whoa, a global var...

sub xprint {
#  print "" . $_[0] . ""; # redefine to no-op to avoid printing
                          # of the file list...
}

sub addhtml { # add to filelist if name ends in htm(l)
              # *** refined for week 6
  my $who = $File::Find::name;
  if (-d $who) { print STDERR "Directory $who\n"; }
  elsif ($who =~ /[.][sp]?htm[l]?$/) { # file name ok?
    if ((-r $who) && (-T $who)) { # readable text file?
      $filelist{$who} = 1;
    } else {
      print STDERR "file gone???: <$who>\n" unless (-e $who);
      print STDERR "no text file: <$who>\n" unless (-T $who);
      print STDERR "cannot read <$who>\n" unless (-r $who);
      open(FOO,"<$who") || die "yuck <$who> $!\n"; close(FOO);
        # $! is the current errno or errname
    }
  } else {
    # print STDERR "not *.[sp]?htm[l]?: $who\n";
  }
}

sub addascii { # add to filelist if ASCII test succeeds
  my $who = $File::Find::name;
  if (-d $who) { print STDERR "Directory $who\n"; }
  if ((-f $who) && (-T $who)) { $filelist{$who} = 1; }
}

sub collecthtmlfiles { # make a list of HTML files in path arg
  my $PFAD;
  $PFAD = $_[0]; # get the where...
  %filelist = ();
  my $count = 0;

  find(\&addhtml, $PFAD);

  print "HTML files found:\n";
  for my $thekey (sort keys %filelist) {
    &xprint("$thekey\n"); $count++;
    if ($thekey =~ /\011/) { # *** week 6: colon <-> DOS, so tab
      print STDERR "Illegal TAB in filename, skipping "
        . "further processing of\n<$thekey>\n";
      $filelist{$thekey} = undef;
    }
  };
  print "$count HTML files found.\n\n";
  return (join("\011",keys %filelist)); # *** week 6: TAB as sep
}

return 1; # make require succeed

